# NOTE: 2.5.35+ can't deal with "[[" "]]" strings in sources, needs workarounds like space separation
#       (or update of m4-quotes patch)
Summary:	GNU fast lexical analyzer generator
Summary(de.UTF-8):	GNU - schneller lexikalischer Analysegenerator
Summary(es.UTF-8):	Generador rápido de analizadores léxicos de la GNU
Summary(fr.UTF-8):	Générateur rapide d'analyseur lexical de GNU
Summary(pl.UTF-8):	Szybki generator analizatora składni GNU (flex)
Summary(pt_BR.UTF-8):	Gerador rápido de analisadores léxicos da GNU
Summary(ru.UTF-8):	Быстрый генератор лексических анализаторов GNU
Summary(tr.UTF-8):	GNU sözdizim çözümleyici
Summary(uk.UTF-8):	Швидкий генератор лексичних аналізаторів GNU
Name:		flex
Version:	2.5.37
Release:	1
License:	BSD-like
Group:		Development/Tools
Source0:	http://downloads.sourceforge.net/flex/%{name}-%{version}.tar.bz2
# Source0-md5:	c75940e1fc25108f2a7b3ef42abdae06
Source1:	http://www.mif.pg.gda.pl/homepages/ankry/man-PLD/%{name}-non-english-man-pages.tar.bz2
# Source1-md5:	fd79ee2834b290e74c626f0bbfc8942f
Patch0:		%{name}-info.patch
Patch1:		%{name}-locale.patch
Patch2:		%{name}-gcc44.patch
# patch #869230 (second version of bug #720983 fix - from flex BTS)
# outdated as for 2.5.34+, but contains testcase
Patch3:		%{name}-m4-quotes.diff
URL:		http://flex.sourceforge.net/
BuildRequires:	autoconf >= 2.54
BuildRequires:	automake >= 1:1.10
BuildRequires:	bison
# to rebuild scan.c from scan.l (m4-quotes patch)
#BuildRequires:	flex
BuildRequires:	gettext-devel >= 0.12
BuildRequires:	help2man
# to rebuild skel.c from patched flex.skl
BuildRequires:	m4
BuildRequires:	texinfo
BuildRequires:	util-linux
Requires:	m4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is the GNU fast lexical analyzer generator. It generates lexical
tokenizing code based on a lexical (regular expression based)
description of the input. It is designed to work with both yacc and
bison, and is used by many programs as part of their build process.

%description -l de.UTF-8
GNU, der schnelle lexikalische Analysengenerator. Er erzeugt
lexikalischen Token-Code, basierend auf einer lexikalischen
Beschreibung (reguläre Ausdrucksbasis) der Eingabe. Ausgelegt zum
Arbeiten mit yacc und bison, wird er von vielen Programmen als Teil
des Build-Vorgangs verwendet.

%description -l es.UTF-8
Este es el creador GNU de análisis léxica rápida. Crea códigos léxicos
tokenizados basados en una descripción léxica (basado en expresiones
regulares) de la entrada. Está designado a trabajar tanto con yacc
como con bison, y se utiliza en varios programas como parte del su
proceso de programación.

%description -l fr.UTF-8
Générateur rapide d'analyseur lexical de GNU. Il génère du code
lexical sous forme de tokens basé sur une description lexicale (basé
sur les expressions rationnelles) de son entrée. Il est conçu pour
fonctionner avec yacc et bison, et est utilisé par de nombreux
programmes comme faisant partie de leur phase de construction.

%description -l pl.UTF-8
GNU flex służy do tworzenia programu analizy leksykalnej na podstawie
wyrażeń regularnych i dyrektyw C zawartych w jednym lub więcej plikach
wejściowych. Przeznaczony do współpracy z parserami yacc i bison, jest
używany przez wiele programów w procesie kompilacji.

%description -l pt_BR.UTF-8
Este é o gerador GNU de análise léxica rápida. Ele gera códigos
léxicos tokenizados baseados em uma descrição léxica (baseado em
expressões regulares) da entrada. Ele é designado para trabalhar tanto
com yacc como com bison, e é utilizado em vários programas como parte
do seu processo de programação.

%description -l ru.UTF-8
Программа flex генерирует сканнеры. Сканнеры - это программы,
способные распознавать лексические шаблоны в тексте. flex принимает на
входе пару регулярных выражений и C код и генерирует исходные файлы на
языке C. Исходный файл компилируется и связывается с библиотекой для
создания исполняемого файла, который будет просматривать свой входной
поток данных в поиске регулярных выражений. При нахождении будет
исполняться заданный C код. flex был разработан для работы как с
системой Yacc, так и Bison, и используется многими программами как
часть процесса их построения из исходных текстов.

Вам следует установить flex, если вы собираетесь использовать свою
систему для разработки программ.

%description -l tr.UTF-8
Bu paket, giriş olarak okuduğu bilgiyi kendisine düzgün deyimler
olarak belirtilen kurallar çerçevesinde birimlere böler. yacc ve bison
paketleri ile birlikte çalışacak şekilde tasarlanmıştır. Pek çok
programın derlenme aşamasında kullanılır.

%description -l uk.UTF-8
Програма flex генерує сканери. Сканери - це програми, які можуть
розпізнавати лексичні шаблони в тексті. flex приймає на вході пару
регулярних виразів та C код та генерує вихідні файли на мові C.
Вихідний файл компілюється та зв'язується з бібліотекою для створення
виконуваного файлу, що проглядатиме свій вхідний потік даних в пошуку
регулярних виразів. При знаходженні виконуватиметься заданий C код.
flex був розроблений для роботи як з системою Yacc, так і Bison, та
використовується багатьма програмами в процесі їх побудови з вихідних
текстів.

Вам слід встановити flex, якщо ви збираєтесь використовувати свою
систему для розробки програм.

%package examples
Summary:	Flex examples
Summary(pl.UTF-8):	Przykłady dla fleksa
Group:		Development/Tools

%description examples
Flex examples.

%description examples -l pl.UTF-8
Przykłady dla fleksa.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
#%patch3 -p1

# force regeneration (just in case make didn't want to)
%{__rm} skel.c

%build
%{__gettextize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

ln -sf flex $RPM_BUILD_ROOT%{_bindir}/lex
ln -sf flex $RPM_BUILD_ROOT%{_bindir}/flex++

echo .so flex.1 > $RPM_BUILD_ROOT%{_mandir}/man1/flex++.1
echo .so flex.1 > $RPM_BUILD_ROOT%{_mandir}/man1/lex.1

bzip2 -dc %{SOURCE1} | tar xf - -C $RPM_BUILD_ROOT%{_mandir}
%{__rm} $RPM_BUILD_ROOT%{_mandir}/README.flex-non-english-man-pages

rm -f $RPM_BUILD_ROOT%{_infodir}/dir

cp -a examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%postun	-p /sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc AUTHORS COPYING ChangeLog NEWS README THANKS TODO
%attr(755,root,root) %{_bindir}/flex
%attr(755,root,root) %{_bindir}/flex++
%attr(755,root,root) %{_bindir}/lex
%{_mandir}/man1/flex.1*
%{_mandir}/man1/flex++.1*
%{_mandir}/man1/lex.1*
%lang(es) %{_mandir}/es/man1/*
%lang(ja) %{_mandir}/ja/man1/*
%lang(pl) %{_mandir}/pl/man1/*
%{_infodir}/flex.info*
%{_libdir}/libfl.a
%{_libdir}/libfl_pic.a
%{_includedir}/FlexLexer.h

%files examples
%defattr(644,root,root,755)
%{_examplesdir}/%{name}-%{version}
%changelog
* Wed Aug 29 2012 Jakub Bogusz <qboosh@pld-linux.org> d86244b
- updated to 2.5.37
- removed obsolete missing-prototypes,sign patches

* Mon May 23 2011 lisu <lisu@pld-linux.org> 2ad2ae4
- seems to work fine, rel 1

* Thu Nov 25 2010 Jakub Bogusz <qboosh@pld-linux.org> 4f89261
- added gcc44,missing-prototypes,sign patches from Fedora (error or warning fixes)
- outdated (no longer applying) m4-quotes patch left for still valid testcase
- passing -fPIC through specflags is not valid (not used in debug builds);
  also, libfl_pic.a (-lfl_pic) instead of libfl.a should be used where PIC is needed

* Sun May 16 2010 Elan Ruusamäe <glen@pld-linux.org> f0deafa
- up to 2.5.35, can't find bug #720983 for -m4-quotes.diff patch

* Thu May 13 2010 sparky <sparky@pld-linux.org> beff317
- release: 4 (because of missing R: m4; STBR)

* Mon Nov 24 2008 pawelz <pawelz@pld-linux.org> e0769a9
- R: m4 (see info flex -> "M4 Dependency")

* Sun Jul 27 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> ef10162
- release 3

* Sun Feb 10 2008 Jakub Bogusz <qboosh@pld-linux.org> 0ea57ae
- anti-upgrade note

* Thu Jan 24 2008 Elan Ruusamäe <glen@pld-linux.org> 31e4193
- invoke fix-info-dir via /sbin/postshell where possible to avoid extra /bin/sh dep

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> d34bc9e
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 17e232a
- converted to UTF-8

* Sun May 14 2006 Paweł Sikora <pluto@pld-linux.org> 33c1fa5
- force -fPIC (for static lib) to able to use libfl.a in sahred objects.
- release 2.

* Thu Mar 16 2006 Elan Ruusamäe <glen@pld-linux.org> 4652bdc
- looks like CVE-2006-0459 is included in 2.5.33

* Tue Mar 07 2006 Jakub Bogusz <qboosh@pld-linux.org> c60e3a0
- updated to 2.5.33 (fixes CVE-2006-0975, CVE-2006-0459)
- updated glibc22,locale patches, removed obsolete yymore-fix,yytext_ptr,posix
  patches and pl.po
- new URLs

* Tue Mar 07 2006 Jakub Bogusz <qboosh@pld-linux.org> 50a5708
- updated for 2.5.33

* Tue Mar 07 2006 Jakub Bogusz <qboosh@pld-linux.org> 270b66a
- obsolete

* Sun Dec 25 2005 twittner <twittner@pld-linux.org> 7f7f141
- get rid of @samp{sth} in generated info page (extended -info.patch)
- added subpkg. with flex examples
- rel. 10

* Sun Dec 25 2005 twittner <twittner@pld-linux.org> c1c8c6e
- get rid of @samp{sth} in generated info page

* Sat Mar 26 2005 Mariusz Mazur <mmazur@pld-linux.org> 5f78d36
- rel 9 for th

* Sat Jul 31 2004 Jakub Bogusz <qboosh@pld-linux.org> cb3d4f2
- cleanup

